(in-package "MORPHICL")

(defclass format-morph (morph)
  ((control-string      :type string
                        :initarg :control-string 
                        :accessor format-morph-control-string)
   (values              :type list
                        :initarg :values         
                        :initform '()
                        :accessor format-morph-values)))

(defmethod morph-draw ((morph format-morph) (canvas canvas))
  (when (format-morph-values morph)
    (canvas-draw-text canvas 
                      (apply #'format 
                             nil
                             (format-morph-control-string morph)
                             (format-morph-values morph))
                      (canvas-transform-point canvas (make-point 0 0)))))

