(in-package "MORPHICL")

(defclass grabbable-morph (morph)
  ())

(defmethod morph-handle-event :around ((morph grabbable-morph) (event pointer-button-press-event)) 
  (cond
    ((eq (pointer-button-event-button event) +pointer-button-right+)
       (morph-remove-submorph (morph-owner morph) morph)
       (morph-add-submorph (port-world (event-port event)) morph)
       (push morph (port-baggage (event-port event))))
    (t
       (call-next-method))))

(defmethod morph-find-submorph-at :around ((morph grabbable-morph) (point point))
  (if (find morph (port-baggage *default-port*))
      (let ((submorph (call-next-method)))
        (if (eq submorph morph)
            (morph-owner morph)
            submorph))
      (call-next-method)))

